//===- TableGen'erated file -------------------------------------*- C++ -*-===//
//
// LLVMC Configuration Library
//
// Automatically generated file, do not edit!
//
//===----------------------------------------------------------------------===//

cl::list<std::string> AutoGeneratedPrefixListl("l", cl::Prefix, cl::desc("search a library when linking"));
cl::list<std::string> AutoGeneratedPrefixListWl("Wl", cl::Prefix, cl::desc("pass options to linker"));
cl::list<std::string> AutoGeneratedPrefixListWa("Wa", cl::Prefix, cl::desc("pass options to assembler"));
cl::opt<bool> AutoGeneratedSwitchS("S", cl::desc("Stop after compilation, do not assemble"));
cl::opt<bool> AutoGeneratedSwitchc("c", cl::desc("Compile and assemble, but do not link"));
cl::opt<bool> AutoGeneratedSwitchE("E", cl::desc("Stop after the preprocessing stage, do not run the compiler"));
cl::opt<bool> AutoGeneratedSwitchopt("opt", cl::desc("Enable opt"));
cl::opt<std::string> AutoGeneratedParameterlinker("linker", cl::desc("Choose linker (possible values: gcc, g++)"));
cl::list<std::string> AutoGeneratedPrefixListL("L", cl::Prefix, cl::desc("add a directory to link path"));
cl::list<std::string> AutoGeneratedSinkOption(cl::Sink);

void llvmc::PopulateLanguageMap(LanguageMap& language_map) {
    language_map["cc"] = "c++";
    language_map["cp"] = "c++";
    language_map["cxx"] = "c++";
    language_map["cpp"] = "c++";
    language_map["CPP"] = "c++";
    language_map["c++"] = "c++";
    language_map["C"] = "c++";
    language_map["c"] = "c";
    language_map["s"] = "assembler";
    language_map["ll"] = "llvm-assembler";
    language_map["bc"] = "llvm-bitcode";
    language_map["o"] = "object-code";
    language_map["out"] = "executable";
}

class llc : public Tool {
public:
    const char* Name() const {
        return "llc";
    }

    const char* InputLanguage() const {
        return "llvm-bitcode";
    }

    const char* OutputLanguage() const {
        return "assembler";
    }

    const char* OutputSuffix() const {
        return "s";
    }

    bool IsJoin() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        const llvm::sys::Path& outFile) const
    {
        throw std::runtime_error("llc is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        const sys::Path& outFile) const
    {
        std::vector<std::string> vec;
        vec.push_back("-f");
        vec.push_back(inFile.toString());
        vec.push_back("-o");
        vec.push_back(outFile.toString());
        if (AutoGeneratedSwitchS) {
        }
        return Action("llc", vec);
    }

    bool IsLast() const {
        bool last = false;
        if (AutoGeneratedSwitchS)
            last = true;
        return last;
    }

};

class llvm_as : public Tool {
public:
    const char* Name() const {
        return "llvm_as";
    }

    const char* InputLanguage() const {
        return "llvm-assembler";
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    const char* OutputSuffix() const {
        return "bc";
    }

    bool IsJoin() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        const llvm::sys::Path& outFile) const
    {
        throw std::runtime_error("llvm_as is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        const sys::Path& outFile) const
    {
        std::vector<std::string> vec;
        vec.push_back(inFile.toString());
        vec.push_back("-o");
        vec.push_back(outFile.toString());
        return Action("llvm-as", vec);
    }

    bool IsLast() const {
        bool last = false;
        return last;
    }

};

class llvm_gcc_assembler : public Tool {
public:
    const char* Name() const {
        return "llvm_gcc_assembler";
    }

    const char* InputLanguage() const {
        return "assembler";
    }

    const char* OutputLanguage() const {
        return "object-code";
    }

    const char* OutputSuffix() const {
        return "o";
    }

    bool IsJoin() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        const llvm::sys::Path& outFile) const
    {
        throw std::runtime_error("llvm_gcc_assembler is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        const sys::Path& outFile) const
    {
        std::vector<std::string> vec;
        vec.push_back("-c");
        vec.push_back("-x");
        vec.push_back("assembler");
        vec.push_back(inFile.toString());
        vec.push_back("-o");
        vec.push_back(outFile.toString());
        if (!AutoGeneratedPrefixListWa.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListWa.begin(),
            E = AutoGeneratedPrefixListWa.end(); B != E; ++B)
                llvm::SplitString(*B, vec, ",");
        }
        if (AutoGeneratedSwitchc) {
        }
        return Action("llvm-gcc", vec);
    }

    bool IsLast() const {
        bool last = false;
        if (AutoGeneratedSwitchc)
            last = true;
        return last;
    }

};

class llvm_gcc_c : public Tool {
public:
    const char* Name() const {
        return "llvm_gcc_c";
    }

    const char* InputLanguage() const {
        return "c";
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    const char* OutputSuffix() const {
        return "bc";
    }

    bool IsJoin() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        const llvm::sys::Path& outFile) const
    {
        throw std::runtime_error("llvm_gcc_c is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        const sys::Path& outFile) const
    {
        std::vector<std::string> vec;
        vec.push_back("-c");
        vec.push_back("-x");
        vec.push_back("c");
        vec.push_back(inFile.toString());
        vec.push_back("-o");
        vec.push_back(outFile.toString());
        vec.push_back("-emit-llvm");
        if (AutoGeneratedSwitchE) {
        }
        if (!AutoGeneratedSinkOption.empty()) {
            vec.insert(vec.end(), AutoGeneratedSinkOption.begin(), AutoGeneratedSinkOption.end());
        }
        return Action("llvm-gcc", vec);
    }

    bool IsLast() const {
        bool last = false;
        if (AutoGeneratedSwitchE)
            last = true;
        return last;
    }

};

class llvm_gcc_cpp : public Tool {
public:
    const char* Name() const {
        return "llvm_gcc_cpp";
    }

    const char* InputLanguage() const {
        return "c++";
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    const char* OutputSuffix() const {
        return "bc";
    }

    bool IsJoin() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        const llvm::sys::Path& outFile) const
    {
        throw std::runtime_error("llvm_gcc_cpp is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        const sys::Path& outFile) const
    {
        std::vector<std::string> vec;
        vec.push_back("-c");
        vec.push_back("-x");
        vec.push_back("c++");
        vec.push_back(inFile.toString());
        vec.push_back("-o");
        vec.push_back(outFile.toString());
        vec.push_back("-emit-llvm");
        if (AutoGeneratedSwitchE) {
        }
        if (!AutoGeneratedSinkOption.empty()) {
            vec.insert(vec.end(), AutoGeneratedSinkOption.begin(), AutoGeneratedSinkOption.end());
        }
        return Action("llvm-g++", vec);
    }

    bool IsLast() const {
        bool last = false;
        if (AutoGeneratedSwitchE)
            last = true;
        return last;
    }

};

class llvm_gcc_cpp_linker : public JoinTool {
public:
    const char* Name() const {
        return "llvm_gcc_cpp_linker";
    }

    const char* InputLanguage() const {
        return "object-code";
    }

    const char* OutputLanguage() const {
        return "executable";
    }

    const char* OutputSuffix() const {
        return "out";
    }

    bool IsJoin() const {
        return true;
    }

    Action GenerateAction(const PathVector& inFiles,
        const sys::Path& outFile) const
    {
        std::vector<std::string> vec;
        for (PathVector::const_iterator B = inFiles.begin(), E = inFiles.end();
        B != E; ++B)
            vec.push_back(B->toString());
        vec.push_back("-o");
        vec.push_back(outFile.toString());
        if (!AutoGeneratedPrefixListl.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListl.begin(),
            E = AutoGeneratedPrefixListl.end(); B != E; ++B)
                vec.push_back("-l" + *B);
        }
        if (!AutoGeneratedPrefixListWl.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListWl.begin(),
            E = AutoGeneratedPrefixListWl.end(); B != E; ++B)
                llvm::SplitString(*B, vec, ",");
        }
        if (!AutoGeneratedParameterlinker.empty()) {
        }
        if (!AutoGeneratedPrefixListL.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListL.begin(),
            E = AutoGeneratedPrefixListL.end(); B != E; ++B)
                vec.push_back("-L" + *B);
        }
        return Action("llvm-g++", vec);
    }

    Action GenerateAction(const sys::Path& inFile,
        const sys::Path& outFile) const
    {
        std::vector<std::string> vec;
        vec.push_back(inFile.toString());
        vec.push_back("-o");
        vec.push_back(outFile.toString());
        if (!AutoGeneratedPrefixListl.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListl.begin(),
            E = AutoGeneratedPrefixListl.end(); B != E; ++B)
                vec.push_back("-l" + *B);
        }
        if (!AutoGeneratedPrefixListWl.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListWl.begin(),
            E = AutoGeneratedPrefixListWl.end(); B != E; ++B)
                llvm::SplitString(*B, vec, ",");
        }
        if (!AutoGeneratedParameterlinker.empty()) {
        }
        if (!AutoGeneratedPrefixListL.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListL.begin(),
            E = AutoGeneratedPrefixListL.end(); B != E; ++B)
                vec.push_back("-L" + *B);
        }
        return Action("llvm-g++", vec);
    }

    bool IsLast() const {
        bool last = false;
        return last;
    }

};

class llvm_gcc_linker : public JoinTool {
public:
    const char* Name() const {
        return "llvm_gcc_linker";
    }

    const char* InputLanguage() const {
        return "object-code";
    }

    const char* OutputLanguage() const {
        return "executable";
    }

    const char* OutputSuffix() const {
        return "out";
    }

    bool IsJoin() const {
        return true;
    }

    Action GenerateAction(const PathVector& inFiles,
        const sys::Path& outFile) const
    {
        std::vector<std::string> vec;
        for (PathVector::const_iterator B = inFiles.begin(), E = inFiles.end();
        B != E; ++B)
            vec.push_back(B->toString());
        vec.push_back("-o");
        vec.push_back(outFile.toString());
        if (!AutoGeneratedPrefixListWl.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListWl.begin(),
            E = AutoGeneratedPrefixListWl.end(); B != E; ++B)
                llvm::SplitString(*B, vec, ",");
        }
        if (!AutoGeneratedPrefixListL.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListL.begin(),
            E = AutoGeneratedPrefixListL.end(); B != E; ++B)
                vec.push_back("-L" + *B);
        }
        if (!AutoGeneratedPrefixListl.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListl.begin(),
            E = AutoGeneratedPrefixListl.end(); B != E; ++B)
                vec.push_back("-l" + *B);
        }
        return Action("llvm-gcc", vec);
    }

    Action GenerateAction(const sys::Path& inFile,
        const sys::Path& outFile) const
    {
        std::vector<std::string> vec;
        vec.push_back(inFile.toString());
        vec.push_back("-o");
        vec.push_back(outFile.toString());
        if (!AutoGeneratedPrefixListWl.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListWl.begin(),
            E = AutoGeneratedPrefixListWl.end(); B != E; ++B)
                llvm::SplitString(*B, vec, ",");
        }
        if (!AutoGeneratedPrefixListL.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListL.begin(),
            E = AutoGeneratedPrefixListL.end(); B != E; ++B)
                vec.push_back("-L" + *B);
        }
        if (!AutoGeneratedPrefixListl.empty()) {
            for (cl::list<std::string>::iterator B = AutoGeneratedPrefixListl.begin(),
            E = AutoGeneratedPrefixListl.end(); B != E; ++B)
                vec.push_back("-l" + *B);
        }
        return Action("llvm-gcc", vec);
    }

    bool IsLast() const {
        bool last = false;
        return last;
    }

};

class opt : public Tool {
public:
    const char* Name() const {
        return "opt";
    }

    const char* InputLanguage() const {
        return "llvm-bitcode";
    }

    const char* OutputLanguage() const {
        return "llvm-bitcode";
    }

    const char* OutputSuffix() const {
        return "bc";
    }

    bool IsJoin() const {
        return false;
    }

    Action GenerateAction(const PathVector& inFiles,
        const llvm::sys::Path& outFile) const
    {
        throw std::runtime_error("opt is not a Join tool!");
    }

    Action GenerateAction(const sys::Path& inFile,
        const sys::Path& outFile) const
    {
        std::vector<std::string> vec;
        vec.push_back(inFile.toString());
        vec.push_back("-o");
        vec.push_back(outFile.toString());
        if (AutoGeneratedSwitchopt) {
        }
        return Action("opt", vec);
    }

    bool IsLast() const {
        bool last = false;
        return last;
    }

};

class Edge7: public Edge {
public:
    Edge7() : Edge("opt") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if (AutoGeneratedSwitchopt)
            ret += 2;
        return ret;
    };

};

class Edge8: public Edge {
public:
    Edge8() : Edge("opt") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if (AutoGeneratedSwitchopt)
            ret += 2;
        return ret;
    };

};

class Edge9: public Edge {
public:
    Edge9() : Edge("opt") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if (AutoGeneratedSwitchopt)
            ret += 2;
        return ret;
    };

};

class Edge13: public Edge {
public:
    Edge13() : Edge("llvm_gcc_cpp_linker") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if (InLangs.count("c++") != 0)
            ret += 2;
        if ((AutoGeneratedParameterlinker == "g++")
             || (AutoGeneratedParameterlinker == "c++"))
            ret += 2;
        return ret;
    };

};

class Edge15: public Edge {
public:
    Edge15() : Edge("llvm_gcc_cpp_linker") {}

    unsigned Weight(const InputLanguagesSet& InLangs) const {
        unsigned ret = 0;
        if (InLangs.count("c++") != 0)
            ret += 2;
        if ((AutoGeneratedParameterlinker == "g++")
             || (AutoGeneratedParameterlinker == "c++"))
            ret += 2;
        return ret;
    };

};

void llvmc::PopulateCompilationGraph(CompilationGraph& G) {
    PopulateLanguageMap(G.ExtsToLangs);

    G.insertNode(new llc());
    G.insertNode(new llvm_as());
    G.insertNode(new llvm_gcc_assembler());
    G.insertNode(new llvm_gcc_c());
    G.insertNode(new llvm_gcc_cpp());
    G.insertNode(new llvm_gcc_cpp_linker());
    G.insertNode(new llvm_gcc_linker());
    G.insertNode(new opt());

    G.insertEdge("root", new SimpleEdge("llvm_gcc_c"));
    G.insertEdge("root", new SimpleEdge("llvm_gcc_assembler"));
    G.insertEdge("root", new SimpleEdge("llvm_gcc_cpp"));
    G.insertEdge("root", new SimpleEdge("llvm_as"));
    G.insertEdge("llvm_gcc_c", new SimpleEdge("llc"));
    G.insertEdge("llvm_gcc_cpp", new SimpleEdge("llc"));
    G.insertEdge("llvm_as", new SimpleEdge("llc"));
    G.insertEdge("llvm_gcc_c", new Edge7());
    G.insertEdge("llvm_gcc_cpp", new Edge8());
    G.insertEdge("llvm_as", new Edge9());
    G.insertEdge("opt", new SimpleEdge("llc"));
    G.insertEdge("llc", new SimpleEdge("llvm_gcc_assembler"));
    G.insertEdge("llvm_gcc_assembler", new SimpleEdge("llvm_gcc_linker"));
    G.insertEdge("llvm_gcc_assembler", new Edge13());
    G.insertEdge("root", new SimpleEdge("llvm_gcc_linker"));
    G.insertEdge("root", new Edge15());
}

